-----2Gen's New Weapons Mod; version: 1.3-----

local storage = {

--------------------CONFIGS--------------------

-- "true" to enable, "false" to disable, or number
-- ids of used hudtxt- 0 for ammo, 1 for dropped weapons names

recoil=true, -- to turn on/off recoil for all weapons, hax ting
blood_effects_value=15, --amount of blood partics while bullet hit npc/player
sparkles_effect_value=5, --amount of sparkles while shooting in the walls
smoke_effects=true, -- smoke effect while shooting
gunfire_sprite_effect=true, -- gunfire effect while shooting, represents in sprite sheet, can be disabled for better performance
laser_sights=1, --0 deactivate laser sights, 1 activate only for custom weapons, 2 activate for all weapons, on "mouse3" key (MMB), visible for all players ("H" to change laser color)
custom_buy_menu=true, -- buy menu with all custom weapons on "X" key, Info_NoBuying entity will also disable this menu; you should be in the Buyzone area (spawn) and buytime must be not passed
info_messages=true, --display info about hotkeys for every player after spawn
ammo_hudtxt_position=2, --2 classic position for ammo hud, 1- on the center of the screen near the player
ammo_hudtxt_color="200190000", --color of ammo hud, RGB number (255000000 for red, 000255000 for green, 200190000 classic color, etc)

explode_breakables=false, --there are no commands for setting health of env_breakable, so you can damage them with custom weapon by dint of spawning explosions, looks ugly and may cause lags, better to disable
buy_menu_always=false, -- activates the buy menu anywhere regardless of buytime, zone etc, hax ting
--v1.1
npc_hitbox = 15, -- distance in pixels between bullet and npc to deal damage
player_hitbox = 10, --same, for players
--v1.2
laser_hotkey = "mouse3",-- hot key for laser sight
laser_color_hotkey = "H",
buy_menu_hotkey = "X",
--v1.3
bullet_line_sprite_effect=true, -- sprites of bullets lines while shooting, disable for better performance

-----WEAPON CONFIGS, ADDING NEW-----
weapons_data={
	[1]={--weapon id
		name = "AK-12", -- name of your weapon, for killing massages and dropped weapon
		path_e = "gfx/! 2gen weapons/ak12.png",-- equipped image
		e_scale1 = 0.5,-- scale foe equipped image, 1 for 32x, 0.5 for 64x etc, width (increase it for small sprites, reduce for large)
		e_scale2 = 0.5,-- same, for height
		path_d = "gfx/! 2gen weapons/ak12_d.png",-- drop image (on the floor)
		d_scale1 = 0.2, --same, for drop image
		d_scale2 = 0.2,
		sounds = {-- weapon sounds, 1 or more files
			[1] = "! 2gen weapons/ak74_shoot1.ogg",
			[2] = "! 2gen weapons/ak74_shoot2.ogg",
			[3] = "! 2gen weapons/ak74_shoot3.ogg",
			[4] = "! 2gen weapons/ak74_shoot4.ogg",
			},		
		type = "rifle",--affects on the equipment slot (2- pistol, seconndary weapon slot and 1- all others, primary weapon), movement speed and reloading speed
		--types: rifle, pistol, smg, machine gun, sniper 1x scope, sniper 2x scope, shotgun
		ammo_mag = 30,-- ammo in magazine	
		ammo_bag = 120,-- additional carried ammo
		fire_rate_timer = 130,-- lower value - higher rate of fire, minimum recommended value 60
		damage = 21,-- weapon damage
		recoil_force = 5,-- in degrees, maximum bullet deflection from a straight trajectory, random number between 1 and recoil_force number
		silence = false, -- true = disable gunfire and bullet lines effects for this weapon (invisible shooting)		
		scope1x_damage_multiplier = 1, --damage bonus while shooting through scope 1- default value, 1.5- +50%, 0.5 - -50% (= damage*multiplier); leave it, if weapon don't have scope
		scope2x_damage_multiplier = 1, -- same, for 2x scope
		cost = 100, -- item cost in shop menu (X button), -1 to disable item for buying
		--v1.1
		range = 600, --fire range in pixels
		hitbox_modifier = 0, --optional value, acrually you don't need to change it; the number in pixels to which the hitbox will increase (hitbox for npc = npc_hitbox + hitbox_modifier) you can slighty increase it for shotguns (1-10) don't set hight values, or you may deal damage through walls
	},
	
	[2]={
		name = "Colt Python",
		path_e = "gfx/! 2gen weapons/357magnum.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/357magnum_d.png",
		d_scale1 = 0.3,
		d_scale2 = 0.3,
		sounds = {
			[1] = "! 2gen weapons/colt_python1.ogg",
			[2] = "! 2gen weapons/colt_python2.ogg",
			},
		type = "pistol",
		ammo_mag = 6,
		ammo_bag = 60,
		fire_rate_timer = 650,
		damage = 40,
		recoil_force = 3,
		silence = false,
		cost = 300,
		range = 500,
		hitbox_modifier = 0,
	},
	
	[3]={
		name = "Kriss-VS",
		path_e = "gfx/! 2gen weapons/krissv.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/krissv_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.2,
		sounds = {
			[1] = "! 2gen weapons/krissv_1.ogg",
			[2] = "! 2gen weapons/krissv_2.ogg",
			[3] = "! 2gen weapons/krissv_3.ogg",
			},
		type = "smg",
		ammo_mag = 20,
		ammo_bag = 150,
		fire_rate_timer = 115,
		damage = 14,
		recoil_force = 4,
		silence = true,
		cost = 250,
		range = 450,
		hitbox_modifier = 0,
	},
	
	[4]={
		name = "FN SCAR SSR",
		path_e = "gfx/! 2gen weapons/scarh.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/scarh_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.2,
		sounds = {
			[1] = "! 2gen weapons/scar1.ogg",
			},
		type = "sniper 1x scope",
		ammo_mag = 20,
		ammo_bag = 80,
		fire_rate_timer = 400,
		damage = 37,
		recoil_force = 3,
		silence = false,
		scope1x_damage_multiplier = 1.2,
		cost = 100,
		range = 600,
		hitbox_modifier = 0,
	},
	
	[5]={
		name = "SVD",
		path_e = "gfx/! 2gen weapons/dragunov.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/dragunov_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.2,
		sounds = {
			[1] = "! 2gen weapons/svd1.ogg",
			},
		type = "sniper 2x scope",
		ammo_mag = 10,
		ammo_bag = 50,
		fire_rate_timer = 1100,
		damage = 45,
		recoil_force = 2,
		silence = false,
		scope1x_damage_multiplier = 1.35,
		scope2x_damage_multiplier = 2.5,
		cost = 500,
		range = 600,
		hitbox_modifier = 0,
	},
	
	[6]={
		name = "Makarov",
		path_e = "gfx/! 2gen weapons/makarov.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/makarov_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.18,
		sounds = {
			[1] = "! 2gen weapons/pm_shot1.ogg",
			[2] = "! 2gen weapons/pm_shot2.ogg",
			},
		type = "pistol",
		ammo_mag = 8,
		ammo_bag = 120,
		fire_rate_timer = 350,
		damage = 20,
		recoil_force = 4,
		silence = false,
		cost = 1000,
		range = 450,
		hitbox_modifier = 0,
	},
	
	[7]={
		name = "Fingergun", --bonus weapon :D 
		path_e = "gfx/! 2gen weapons/fingergun.png",
		e_scale1 = 0.6,
		e_scale2 = 0.6,
		path_d = "gfx/! 2gen weapons/fingergun_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.2,
		sounds = {
			[1] = "! 2gen weapons/fingergun_1.ogg",
			[2] = "! 2gen weapons/fingergun_2.ogg",
			[3] = "! 2gen weapons/fingergun_3.ogg",
			[4] = "! 2gen weapons/fingergun_4.ogg",
			[5] = "! 2gen weapons/fingergun_5.ogg",
			[6] = "! 2gen weapons/fingergun_6.ogg",
			},
		type = "pistol",
		ammo_mag = 99,
		ammo_bag = 0,
		fire_rate_timer = 700,
		damage = 0, -- no damage
		recoil_force = 0, -- no recoil
		silence = true,
		cost = -1, -- can't be bought
		range = 100,
		hitbox_modifier = 0,
	},
	
	[8]={
		name = "AS Val",
		path_e = "gfx/! 2gen weapons/asval.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/asval_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.2,
		sounds = {
			[1] = "! 2gen weapons/asval1.ogg",
			[2] = "! 2gen weapons/asval2.ogg",
			[3] = "! 2gen weapons/asval3.ogg",
			[4] = "! 2gen weapons/asval4.ogg",
			[5] = "! 2gen weapons/asval5.ogg",
			},
		type = "rifle",
		ammo_mag = 20,
		ammo_bag = 90,
		fire_rate_timer = 160,
		damage = 26,
		recoil_force = 3,
		silence = true,
		cost = 1550,
		range = 500,
		hitbox_modifier = 0,
	},
	
	[9]={
		name = "RPK-74",
		path_e = "gfx/! 2gen weapons/rpk74.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/rpk74_d.png",
		d_scale1 = 0.2,
		d_scale2 = 0.2,
		sounds = {
			[1] = "! 2gen weapons/rpk_shot.ogg",
			},
		type = "machine gun",
		ammo_mag = 45,
		ammo_bag = 180,
		fire_rate_timer = 140,
		damage = 22,
		recoil_force = 5,
		silence = false,
		cost = 671,
		range = 600,
		hitbox_modifier = 0,
	},
	
	[10]={
		name = "Sawn-off TOZ-66",
		path_e = "gfx/! 2gen weapons/obrez.png",
		e_scale1 = 0.5,
		e_scale2 = 0.5,
		path_d = "gfx/! 2gen weapons/obrez_d.png",
		d_scale1 = 0.17,
		d_scale2 = 0.18,
		sounds = {
			[1] = "! 2gen weapons/obrez.ogg",
			},
		type = "shotgun",
		ammo_mag = 2,
		ammo_bag = 80,
		fire_rate_timer = 150,
		damage = 10,
		recoil_force = 3,
		silence = false,
		cost = 341,
		range = 350,
		hitbox_modifier = 5,
	},
},
-----End of Weapon configs-----

laser_colors = { -- colors for laser sight on H key, RGB code
	[1] = {
		r=255,
		g=0,
		b=0,
	},
	[2] = {
		r=0,
		g=255,
		b=0,
	},
	[3] = {
		r=0,
		g=50,
		b=255,
	},
	[4] = {
		r=0,
		g=255,
		b=255,
	},
	[5] = {
		r=255,
		g=255,
		b=0,
	},
	[6] = {
		r=255,
		g=127,
		b=237,
	},
	[7] = {
		r=255,
		g=0,
		b=255,
	},
	[8] = {
		r=255,
		g=255,
		b=255,
	},
	[9] = {
		r=255,
		g=100,
		b=0,
	},
},

--------------------END OF ALL CONFIGS--------------------

swpn_buildings_ids_tab={[3]=1,[4]=1,[5]=1,[7]=1,[8]=1,[9]=1,[10]=1,[11]=1,[12]=1,[15]=1},--tab with ids of buildings, which can be damaged by custom bullets (all exept barricades and floor buildings, as by default), actually you can edit it, but not recommended

-----Script vars, don't tuch-----

aim_mode=2,--aim_mode 1 was removed since v1.3, don't change
round_timer=0,
round_end=false,

weapons_dropped = {
	[0] = {
		id = 0,
		tilex = 0,
		tiley = 0,
		ammo_mag = 0,
		ammo_bag = 0,
		fadeout_timer = 0,
		infinite = false,
		on_spawn = false,
	},
},

weapon_respawns = {
	[0] = {
	id = 0,
	tilex = 0,
	tiley = 0,
	delay = 0,
	timer = 0,
	spawned = false,
	},
},

player_data={
},

reload_timers = {--don't tuch
	[1] = 220,--ups
	[2] = 220,--glock
	[3] = 210,--deagle
	[4] = 270,--p228
	[5] = 250,--elite
	[6] = 480,--5&7
	
	[10] = 90,--m3
	[11] = 70,--1014
	
	[20] = 230,--mp5
	[21] = 200,--tmp
	[22] = 350,--p90
	[23] = 340,--mac10
	[24] = 350,--ump45
	
	[30] = 275,--ak
	[31] = 250,--sg552
	[32] = 220,--m4a1
	[33] = 420,--aug
	[34] = 180,--scout
	[35] = 400,--awp
	[36] = 460,--g3sg1
	[37] = 450,--sg550
	[38] = 250,--galil
	[39] = 250,--famas
	[40] = 460,--m249
	
	[45] = 200,--laser
	[46] = 200,--flame
	[47] = 500,--rpg
	[48] = 300,--rocket L
	[49] = 300,--grenade L
	
	[90] = 600,--minigun
	[91] = 220,--fn2000
},

screen_res = {
	[1] = {
		w = 850,
		h = 480,
	},
	[2] = {
		w = 1020,
		h = 576,
	},
	[3] = {
		w = 1060,
		h = 598,
	},
	[4] = {
		w = 1147,
		h = 648,
	},
	[5] = {
		w = 1275,
		h = 720,
	},
	[6] = {
		w = 1360,
		h = 768,
	},
	[7] = {
		w = 1440,
		h = 813,
	},
	[8] = {
		w = 1593,
		h = 900,
	},
	[9] = {
		w = 1912,
		h = 1080,
	},
},

}
for k, v in pairs(storage.weapons_data) do
	if storage.weapons_data[k].type=="rifle" then
		storage.weapons_data[k].real_id = 30
		storage.weapons_data[k].slot = 1
		storage.weapons_data[k].id = k
	elseif storage.weapons_data[k].type=="pistol" then
		storage.weapons_data[k].real_id=4
		storage.weapons_data[k].slot = 2
		storage.weapons_data[k].id = k
	elseif storage.weapons_data[k].type=="smg" then
		storage.weapons_data[k].real_id=21
		storage.weapons_data[k].slot = 1
		storage.weapons_data[k].id = k
	elseif storage.weapons_data[k].type=="machine gun" then
		storage.weapons_data[k].real_id=40
		storage.weapons_data[k].slot = 1
		storage.weapons_data[k].id = k
	elseif storage.weapons_data[k].type=="sniper 1x scope" then
		storage.weapons_data[k].real_id=33
		storage.weapons_data[k].slot = 1
		storage.weapons_data[k].id = k
	elseif storage.weapons_data[k].type=="sniper 2x scope" then
		storage.weapons_data[k].real_id=35
		storage.weapons_data[k].slot = 1
		storage.weapons_data[k].id = k
	elseif storage.weapons_data[k].type=="shotgun" then
		storage.weapons_data[k].real_id=23
		storage.weapons_data[k].slot = 1
		storage.weapons_data[k].id = k
	end
end

for id=1,32 do
	storage.player_data[id]={
	wpn_id_slot={[1]=0,[2]=0},
	wpn_image_slot={},
	ammo_mag_slot={[1]=0,[2]=0},
	ammo_bag_slot={[1]=0,[2]=0},
	cursor_x = 0,
	cursor_y = 0,
	widescreen = 0,
	mouse1_pressed=false,
	shoot_timer=false,
	reload_in_process=false,
	reloading_slot=0,
	scope = 0,
	menu_page = 0,
	first_spawn = true,
	p_mx=0,
	p_my=0,
	slot_to_drop=0,
	pid=0,
	laser=false,
	laser_color=1,
	w_selecting=0
	}
end

return storage

--
--
--
--
--