-----2Gen's New Weapons Mod; version: 1.3-----

local storage = dofile("sys/lua/2gen_weapons/storage.lua")

parse("mp_hud 119")--remove ammo string from hud, don't change, script uses custom ammo hud based on hudtxt
parse("mp_hudscale 0")--don't change, optimized only for mp_hudscale 0

addhook("join","swpn_join_hook")
function swpn_join_hook(id)
storage.player_data[id].first_spawn=true
end

addhook("spawn","swpn_spawn_hook")
function swpn_spawn_hook(id)
--local id=tonumber(id)
	if storage.player_data[id].first_spawn then
		
		if storage.bullet_line_sprite_effect then
			storage.player_data[id].bullet_line = image("gfx/! 2gen weapons/1pix.png",0,0,1)
			imagealpha(storage.player_data[id].bullet_line,0)
			imagepos(storage.player_data[id].bullet_line,-500,-500,0)
			
			storage.player_data[id].bullet_line2 = image("gfx/! 2gen weapons/1pix.png",0,0,1)
			imagealpha(storage.player_data[id].bullet_line2,0)
			imagepos(storage.player_data[id].bullet_line2,-500,-500,0)
			
			storage.player_data[id].bullet_line3 = image("gfx/! 2gen weapons/1pix.png",0,0,1)
			imagealpha(storage.player_data[id].bullet_line3,0)
			imagepos(storage.player_data[id].bullet_line3,-500,-500,0)
		end
		storage.player_data[id].hudtxt_back = image("gfx/! 2gen weapons/hudtxt_back.png",0,0,2,id)
		imagealpha(storage.player_data[id].hudtxt_back,0,0)
		imagepos(storage.player_data[id].hudtxt_back,-500,-500,0)
		
		storage.player_data[id].gunfire = image("<spritesheet:gfx/! 2gen weapons/gunfire_sheet.png:160:160>",3,0,200+id)
		imagealpha(storage.player_data[id].gunfire,0)
		
		if storage.laser_sights>0 then
			storage.player_data[id].laser_img = image("gfx/! 2gen weapons/laser_sight.png",1,0,200+id)
			imagealpha(storage.player_data[id].laser_img,0)
			local color = storage.player_data[id].laser_color
			imagecolor(storage.player_data[id].laser_img,storage.laser_colors[color].r,storage.laser_colors[color].g,storage.laser_colors[color].b)
			imageblend(storage.player_data[id].laser_img,1)
		end
		
		storage.player_data[id].first_spawn=false	
		
		storage.player_data[id].pid=id
	end
		storage.player_data[id].laser=false

	if storage.info_messages then
		if storage.custom_buy_menu then
			parse("sv_msg2 "..id.." \169255216000Press ["..storage.buy_menu_hotkey.."] to buy custom weapons")
		end
		if storage.laser_sights>0 then
			parse("sv_msg2 "..id.." \169255216000Press ["..storage.laser_hotkey.."] to turn on/off laser")
			parse("sv_msg2 "..id.." \169255216000and ["..storage.laser_color_hotkey.."] to change laser color")
		end
	end
	storage.player_data[id].w_selecting=0
end

addhook("die","swpn_die_hook")
function swpn_die_hook(id,kid,wid,x,y,oid)
swpn_die_drop(id,x,y)
storage.player_data[id].scope=0
	if storage.laser_sights>0 then
		storage.player_data[id].laser=false
		if storage.player_data[id].laser_img then
			imagealpha(storage.player_data[id].laser_img,0)
		end
	end
end

function swpn_die_drop(id,x,y)
local tilex, tiley = math.floor(x/32), math.floor(y/32)
for slot=1,2 do
	if storage.player_data[id].wpn_id_slot[slot]>0 then
	
	local swpn_id = storage.player_data[id].wpn_id_slot[slot]

if tonumber(game("mp_deathdrop"))<4 then
	local t_key = #storage.weapons_dropped+1
	storage.weapons_dropped[t_key]={}
	storage.weapons_dropped[t_key].image=image(storage.weapons_data[swpn_id].path_d,x,y,0)
	storage.weapons_dropped[t_key].tilex, storage.weapons_dropped[t_key].tiley = tilex, tiley
	storage.weapons_dropped[t_key].id = swpn_id
	storage.weapons_dropped[t_key].ammo_mag=storage.player_data[id].ammo_mag_slot[slot]
	storage.weapons_dropped[t_key].ammo_bag=storage.player_data[id].ammo_bag_slot[slot]
	storage.weapons_dropped[t_key].fadeout_timer = 0
	imagepos(storage.weapons_dropped[t_key].image,x,y,math.random(0,360))
	imagescale(storage.weapons_dropped[t_key].image,storage.weapons_data[storage.weapons_dropped[t_key].id].d_scale1,storage.weapons_data[storage.weapons_dropped[t_key].id].d_scale2)
end

	storage.player_data[id].wpn_id_slot[slot]=0
	storage.player_data[id].ammo_mag_slot[slot]=0
	storage.player_data[id].ammo_bag_slot[slot]=0
	parse('hudtxt2 '..id..' 0 "" 0 0')

	freeimage(storage.player_data[id].wpn_image_slot[slot])
	storage.player_data[id].wpn_image_slot[slot]=nil

	parse("strip "..id.." "..storage.weapons_data[swpn_id].real_id.."")
	end
end
end

addhook("leave","swpn_leave_hook")
function swpn_leave_hook(id,reason)
local id = id
if id~=0 then --fix for error in dedicated server
if storage.player_data[id].gunfire then
	freeimage(storage.player_data[id].gunfire)
	storage.player_data[id].gunfire = nil
end
if storage.bullet_line_sprite_effect then
	if storage.player_data[id].bullet_line then
		freeimage(storage.player_data[id].bullet_line)
		storage.player_data[id].bullet_line = nil
		
		freeimage(storage.player_data[id].bullet_line2)
		storage.player_data[id].bullet_line2 = nil
		
		freeimage(storage.player_data[id].bullet_line3)
		storage.player_data[id].bullet_line3 = nil
	end
end
if storage.player_data[id].hudtxt_back then
	freeimage(storage.player_data[id].hudtxt_back)
	storage.player_data[id].hudtxt_back = nil
end

if storage.laser_sights>0 then
	if storage.player_data[id].laser_img then
		freeimage(storage.player_data[id].laser_img)
		storage.player_data[id].laser_img = nil
	end
end

for slot=1,2 do
	if storage.player_data[id].wpn_id_slot[slot]>0 then
		if storage.player_data[id].wpn_image_slot[slot] then
			freeimage(storage.player_data[id].wpn_image_slot[slot])
		else
			print("Image missing? id "..id.." slot "..slot)
		end		
		storage.player_data[id].wpn_image_slot[slot]=nil
		storage.player_data[id].wpn_id_slot[slot]=0
	end
end
storage.player_data[id].wpn_image_slot={}

storage.player_data[id].mouse1_pressed=false
storage.player_data[id].shoot_timer=false
storage.player_data[id].reload_in_process=false
storage.player_data[id].widescreen = 0
storage.player_data[id].scope=0

storage.player_data[id].pid=0
storage.player_data[id].laser=false
end
end

function swpn_end_del_other_sprites()
--for _,id in pairs(player(0,"table")) do
for id, v in pairs (storage.player_data) do
	if storage.player_data[id].pid~=0 then
		if storage.player_data[id].gunfire then
			freeimage(storage.player_data[id].gunfire)
			storage.player_data[id].gunfire = nil
		end
		if storage.bullet_line_sprite_effect then
			if storage.player_data[id].bullet_line then
				freeimage(storage.player_data[id].bullet_line)
				storage.player_data[id].bullet_line = nil
				
				freeimage(storage.player_data[id].bullet_line2)
				storage.player_data[id].bullet_line2 = nil
				
				freeimage(storage.player_data[id].bullet_line3)
				storage.player_data[id].bullet_line3 = nil
			end
		end
		if storage.player_data[id].hudtxt_back then
			freeimage(storage.player_data[id].hudtxt_back)
			storage.player_data[id].hudtxt_back = nil
		end
		if storage.laser_sights>0 then
			if storage.player_data[id].laser_img then
				freeimage(storage.player_data[id].laser_img)
				storage.player_data[id].laser_img = nil
			end
		end
	end
end
end

function swpn_end_del_entities()
	for k, v in pairs(storage.weapon_respawns) do
		storage.weapon_respawns[k] = nil
	end
		storage.weapon_respawns={}
	
	for k, v in pairs(storage.weapons_dropped) do
		if storage.weapons_dropped[k].image then
			freeimage(storage.weapons_dropped[k].image)
			storage.weapons_dropped[k].image=nil
		end
		storage.weapons_dropped[k]=nil
	end
	storage.weapons_dropped={}
end

function swpn_end_del_player_guns()
	--for _,id in pairs(player(0,"table")) do
	for id, v in pairs (storage.player_data) do
	if storage.player_data[id].pid~=0 then
		for slot=1,2 do
			if storage.player_data[id].wpn_id_slot[slot]>0 then
				if storage.player_data[id].wpn_image_slot[slot] then
					freeimage(storage.player_data[id].wpn_image_slot[slot])
					storage.player_data[id].wpn_image_slot[slot]=nil
				end		
				parse("strip "..id.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[slot]].real_id.."")
				storage.player_data[id].wpn_id_slot[slot]=0
			end
		end
		storage.player_data[id].wpn_image_slot={}
	end
	end
end

function swpn_create_other_sprites_start()
--for _,id in pairs(player(0,"table")) do
for id, v in pairs (storage.player_data) do
	if storage.player_data[id].pid~=0 then
		storage.player_data[id].gunfire = image("<spritesheet:gfx/! 2gen weapons/gunfire_sheet.png:160:160>",3,0,200+id)
		imagealpha(storage.player_data[id].gunfire,0)
		
		if storage.bullet_line_sprite_effect then
			storage.player_data[id].bullet_line = image("gfx/! 2gen weapons/1pix.png",0,0,1)
			imagealpha(storage.player_data[id].bullet_line,0)
			imagepos(storage.player_data[id].bullet_line,-500,-500,0)
			
			storage.player_data[id].bullet_line2 = image("gfx/! 2gen weapons/1pix.png",0,0,1)
			imagealpha(storage.player_data[id].bullet_line2,0)
			imagepos(storage.player_data[id].bullet_line2,-500,-500,0)
			
			storage.player_data[id].bullet_line3 = image("gfx/! 2gen weapons/1pix.png",0,0,1)
			imagealpha(storage.player_data[id].bullet_line3,0)
			imagepos(storage.player_data[id].bullet_line3,-500,-500,0)
		end
		
		storage.player_data[id].hudtxt_back = image("gfx/! 2gen weapons/hudtxt_back.png",0,0,2,id)
		imagealpha(storage.player_data[id].hudtxt_back,0)
		imagepos(storage.player_data[id].hudtxt_back,-500,-500,0)
		
		if storage.laser_sights>0 then
			storage.player_data[id].laser_img = image("gfx/! 2gen weapons/laser_sight.png",1,0,200+id)
			imagealpha(storage.player_data[id].laser_img,0)
			imagecolor(storage.player_data[id].laser_img,255,0,0)	
			imageblend(storage.player_data[id].laser_img,1)
		end
	end
end
end

addhook("endround","swpn_endround_hook")
function swpn_endround_hook(mode)
storage.round_end = true --fix for shopping after endround and ruining images
swpn_end_del_entities()
swpn_end_del_player_guns()
swpn_end_del_other_sprites()
end

addhook("startround","swpn_startround_hook")
function swpn_startround_hook(mode)
swpn_create_other_sprites_start()
swpn_mapentity_wpn_spawn()

storage.round_timer=0
parse("mp_hud 119")
parse("mp_hudscale 0")
storage.round_end = false
end

function swpn_fix_default_ammo_hud(id)
local	id=tonumber(id)

local iid = player(id,"weapontype")
local txtcolor = "©"..storage.ammo_hudtxt_color..""
if itemtype(iid,"slot")==1 or itemtype(iid,"slot")==2 then
	if storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]==0 then
		local a_mag, a_bag = playerammo(id, player(id, "weapontype"))
		if tonumber(game("mp_infammo"))==1 then
			if storage.ammo_hudtxt_position == 1 then
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..a_mag..' | inf" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
			else
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..a_mag..' | inf" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
			end
		else
			if storage.ammo_hudtxt_position == 1 then
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..a_mag..' | '..a_bag..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
			else
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..a_mag..' | '..a_bag..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
			end
		end
	else
		if tonumber(game("mp_infammo"))==1 then
			if storage.ammo_hudtxt_position == 1 then
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(iid,"slot")]..' | inf" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
			else
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(iid,"slot")]..' | inf" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
			end
		else
			if storage.ammo_hudtxt_position == 1 then
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(iid,"slot")]..' | '..storage.player_data[id].ammo_bag_slot[itemtype(iid,"slot")]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
			else
				parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(iid,"slot")]..' | '..storage.player_data[id].ammo_bag_slot[itemtype(iid,"slot")]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
			end
		end

	end
elseif itemtype(iid,"slot")==4 then
	local a_mag, a_bag = playerammo(id, player(id, "weapontype"))
	if storage.ammo_hudtxt_position == 1 then
		parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..a_mag..' | '..a_bag..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
	else
		parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..a_mag..' | '..a_bag..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
	end
else
	parse('hudtxt2 '..id..' 0 "" 0 0')
end
--print("FIX AMMO")
end

addhook("walkover","swpn_walkover")
function swpn_walkover(id,iid,type,ain,a,mode)
local txtcolor = "©"..storage.ammo_hudtxt_color..""
	if type == 61 then
		if storage.player_data[id].wpn_id_slot[1]~=0 then
			if storage.player_data[id].ammo_bag_slot[1] < storage.weapons_data[storage.player_data[id].wpn_id_slot[1]].ammo_bag then
				parse("setammo "..id.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[1]].real_id.." 0")
				storage.player_data[id].ammo_bag_slot[1] = storage.weapons_data[storage.player_data[id].wpn_id_slot[1]].ammo_bag
				if itemtype(player(id,"weapontype"),"slot")==1 then
					if storage.ammo_hudtxt_position == 1 then
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[1]..' | '..storage.player_data[id].ammo_bag_slot[1]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
					else
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[1]..' | '..storage.player_data[id].ammo_bag_slot[1]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
					end
				end
			else
				return 1
			end
		else
			--timer(20, "parse", "lua swpn_fix_default_ammo_hud("..id..")")
			--swpn_fix_default_ammo_hud(id)
			--return 1
		end
	elseif type == 62  then
		if storage.player_data[id].wpn_id_slot[2]~=0 then
			if storage.player_data[id].ammo_bag_slot[2] < storage.weapons_data[storage.player_data[id].wpn_id_slot[2]].ammo_bag then
				parse("setammo "..id.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[2]].real_id.." 0")
				storage.player_data[id].ammo_bag_slot[2] = storage.weapons_data[storage.player_data[id].wpn_id_slot[2]].ammo_bag
				if itemtype(player(id,"weapontype"),"slot")==2 then
					if storage.ammo_hudtxt_position == 1 then
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[2]..' | '..storage.player_data[id].ammo_bag_slot[2]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
					else
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[2]..' | '..storage.player_data[id].ammo_bag_slot[2]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
					end
				end
			else
				return 1
			end
		else
			--timer(20, "parse", "lua swpn_fix_default_ammo_hud("..id..")")
			--swpn_fix_default_ammo_hud(id)
			--return 1
		end	
	elseif itemtype(type,"slot")==1 or itemtype(type,"slot")==2 then
		if itemtype(type,"slot")==1 and storage.player_data[id].wpn_id_slot[1]>0 then
			return 1
		elseif itemtype(type,"slot")==2 and storage.player_data[id].wpn_id_slot[2]>0 then
			return 1
		end
	end

end

function swpn_reloadh_setammo(id, slot)
local id=tonumber(id)
local slot=tonumber(slot)
	if slot==itemtype(player(id,"weapontype"),"slot") then
		parse("setammo "..id.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].real_id.." 0")
	end
end

addhook("reload","swpn_reload_hook")
function swpn_reload_hook(id,mode)

if mode==1 then
	if storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]>0 then
		freetimer("parse", "lua swpn_reloadh_setammo("..id..","..itemtype(player(id,"weapontype"),"slot")..")")
		timer(200, "parse", "lua swpn_reloadh_setammo("..id..","..itemtype(player(id,"weapontype"),"slot")..")")
	end
end

if mode==2 then
	swpn_fix_default_ammo_hud(id)
end
end

addhook("drop","swpn_drop_hook")
function swpn_drop_hook(id,iid,type,ammoin,adammo,mode,tilex,tiley)
	if storage.player_data[id].slot_to_drop~=-1 then
		if storage.player_data[id].slot_to_drop~=itemtype(type,"slot") then
			storage.player_data[id].slot_to_drop=-1
			return 1 --fix for bug when you can drop two weapons
		end
	end
end

function swpn_drop_bind(id)
if (itemtype(player(id,"weapontype"),"slot")==1 and storage.player_data[id].wpn_id_slot[1]>0) or (itemtype(player(id,"weapontype"),"slot")==2 and storage.player_data[id].wpn_id_slot[2]>0) then	
--if (storage.player_data[id].slot_to_dop==1 and storage.player_data[id].wpn_id_slot[1]>0) or (storage.player_data[id].slot_to_dop==2 and storage.player_data[id].wpn_id_slot[2]>0) then	
	local tilex, tiley = player(id,"tilex"), player(id,"tiley")
	local x = tilex*32+16
	local y = tiley*32+16
	local slot = itemtype(player(id,"weapontype"),"slot")
	--storage.player_data[id].slot_to_dop=slot
	--local slot = storage.player_data[id].slot_to_dop
	local swpn_id = storage.player_data[id].wpn_id_slot[slot]

	parse("strip "..id.." "..storage.weapons_data[swpn_id].real_id.."")
	
	local t_key = #storage.weapons_dropped+1
	
	storage.weapons_dropped[t_key]={}
	storage.weapons_dropped[t_key].image=image(storage.weapons_data[swpn_id].path_d,x,y,0)
	storage.weapons_dropped[t_key].tilex, storage.weapons_dropped[t_key].tiley = tilex, tiley
	storage.weapons_dropped[t_key].id = swpn_id
	storage.weapons_dropped[t_key].ammo_mag=storage.player_data[id].ammo_mag_slot[slot]
	storage.weapons_dropped[t_key].ammo_bag=storage.player_data[id].ammo_bag_slot[slot]
	storage.weapons_dropped[t_key].fadeout_timer = 0
	imagepos(storage.weapons_dropped[t_key].image,x,y,math.random(0,360))
	imagescale(storage.weapons_dropped[t_key].image,storage.weapons_data[storage.weapons_dropped[t_key].id].d_scale1,storage.weapons_data[storage.weapons_dropped[t_key].id].d_scale2)

	storage.player_data[id].wpn_id_slot[slot]=0
	storage.player_data[id].ammo_mag_slot[slot]=0
	storage.player_data[id].ammo_bag_slot[slot]=0
	parse('hudtxt2 '..id..' 0 "" 0 0')

	freeimage(storage.player_data[id].wpn_image_slot[slot])
	storage.player_data[id].wpn_image_slot[slot]=nil
	
	if storage.player_data[id].reload_in_process then
		storage.player_data[id].reload_in_process = false
		freetimer("parse", "lua swpn_reload_finish("..id..")")
	end

	parse('sv_soundpos "items/drop.wav" '..player(id, "x")..' '..player(id, "y"))
	return

end
end

function swpn_classic_wpn_slot1(id,k)
	for _,wid in pairs(playerweapons(id)) do	
		if itemtype(wid,"slot")==1 then
		return true
		end
	end
	return false
end

function swpn_classic_wpn_slot2(id,k)
	for _,wid in pairs(playerweapons(id)) do	
		if itemtype(wid,"slot")==2 then
		return true
		end
	end
	return false
end

addhook("movetile","swpn_movetile_hook")
function swpn_movetile_hook(id,ptilex,ptiley)
	for k, v in pairs(storage.weapons_dropped) do
	if storage.weapons_dropped[k].id then
		if storage.weapons_dropped[k].id > 0 then
			if ptilex==storage.weapons_dropped[k].tilex and ptiley==storage.weapons_dropped[k].tiley then
			
				if storage.player_data[id].wpn_id_slot[storage.weapons_data[storage.weapons_dropped[k].id].slot] == 0 then
					if not (tonumber(game("sv_gamemode"))==4 and player(id,"team")==1) then--fix for armored zombiez
						if storage.weapons_data[storage.weapons_dropped[k].id].slot == 1 then
							if not swpn_classic_wpn_slot1(id,k) then						
								if not storage.weapons_dropped[k].infinite then
									freeimage(storage.weapons_dropped[k].image)
									storage.weapons_dropped[k].image=nil
								end
								swpn_pickup_weapon(id,k)
							end
						elseif storage.weapons_data[storage.weapons_dropped[k].id].slot == 2 then
							if not swpn_classic_wpn_slot2(id,k) then
				
								if not storage.weapons_dropped[k].infinite then
									freeimage(storage.weapons_dropped[k].image)
									storage.weapons_dropped[k].image=nil
								end
								swpn_pickup_weapon(id,k)
							end
						end
					end
				end
			end
		end
	end
	end
end

addhook("rcon","swpn_rcon_hook")
function swpn_rcon_hook(cmd,id)
	if swpn_console_parse_hook(cmd)==2 then
		return 1
	end
end

addhook("parse","swpn_console_parse_hook")
function swpn_console_parse_hook(cmd)
	local words=0
	local w1, w2, w3, w4
	for word in string.gmatch(cmd, "[^%s]+") do
		words=words+1
		if words==1 then
			w1=word
		elseif words==2 then
			w2=word
		elseif words==3 then
			w3=word
		elseif words==4 then
			w4=word
			words=0
		end
	end
	
	if w1=="wequip" then
		if w2 and w3 then
			w2=tonumber(w2)
			w3=tonumber(w3)
			swpn_equip_new_weapon(w2,w3)
		end	
		return 2
	elseif w1=="wstrip" then
		if w2 and w3 then
			w2=tonumber(w2)
			w3=tonumber(w3)
			swpn_strip_new_weapon(w2,w3)
		end	
		return 2
	elseif w1=="wspawn" then
		if w2 and w3 then
			w2=tonumber(w2)
			w3=tonumber(w3)
			w4=tonumber(w4)
			swpn_spawn_new_weapon(w2,w3,w4)
		end	
		return 2
	end
	
	if w1=="equip" then
		w2=tonumber(w2)
		w3=tonumber(w3)
		if w3~=nil then
			if storage.player_data[w2].wpn_id_slot[itemtype(w3,"slot")] and storage.player_data[w2].wpn_id_slot[itemtype(w3,"slot")]>0 then
				swpn_strip_new_weapon(w2,storage.player_data[w2].wpn_id_slot[itemtype(w3,"slot")])
			end
		end
	end
end

function swpn_spawn_new_weapon(wid,tx,ty,ent_spw_mode,ent_spw_delay)
	if storage.weapons_data[wid] then
		if tile(tx, ty, "walkable") then
			local x = tx*32+16
			local y = ty*32+16

			local t_key = #storage.weapons_dropped+1
			local slot = storage.weapons_data[wid].slot
			storage.weapons_dropped[t_key]={}
			storage.weapons_dropped[t_key].image=image(storage.weapons_data[wid].path_d,x,y,0)
			storage.weapons_dropped[t_key].tilex, storage.weapons_dropped[t_key].tiley = tx, ty
			storage.weapons_dropped[t_key].id = wid
			storage.weapons_dropped[t_key].ammo_mag=storage.weapons_data[wid].ammo_mag
			storage.weapons_dropped[t_key].ammo_bag=storage.weapons_data[wid].ammo_bag
			--storage.weapons_dropped[t_key].fadeout_timer = 0 -- don't fade spawned items
			imagepos(storage.weapons_dropped[t_key].image,x,y,math.random(0,360))
			imagescale(storage.weapons_dropped[t_key].image,storage.weapons_data[wid].d_scale1,storage.weapons_data[wid].d_scale2)
			
			if ent_spw_mode then
				if ent_spw_mode==1 then
					storage.weapons_dropped[t_key].infinite = true
				elseif ent_spw_mode==2 then
					storage.weapons_dropped[t_key].respawn_timer = ent_spw_delay
					storage.weapons_dropped[t_key].ent_tilex = tx
					storage.weapons_dropped[t_key].ent_tiley = ty
					storage.weapons_dropped[t_key].on_spawn = false
				end
			end
		end
	end
end

function swpn_mapentity_wpn_spawn()
	for _,e in pairs(entitylist()) do
		if entity(e.x,e.y,"typename")=="Env_Item" then
			if entity(e.x,e.y,"name")=="swpn" then
				if entity(e.x,e.y,"trigger") then
					local wid = tonumber(entity(e.x,e.y,"trigger"))
					if storage.weapons_data[wid] then
						local ent_spw_mode = entity(e.x,e.y,"int1")
						local ent_spw_delay = entity(e.x,e.y,"int2")
						swpn_spawn_new_weapon(wid,e.x,e.y,ent_spw_mode,ent_spw_delay)
					end
				end
			end
		end
	end
end
swpn_mapentity_wpn_spawn()

function swpn_strip_new_weapon(id,wid)
if player(id,"health") and player(id,"health")>0 and storage.weapons_data[wid] then
	if storage.player_data[id].wpn_id_slot[storage.weapons_data[wid].slot] ~= 0 then
		local rwid=storage.weapons_data[wid].real_id

		local slot=storage.weapons_data[wid].slot
		storage.player_data[id].wpn_id_slot[storage.weapons_data[wid].slot]=0
		storage.player_data[id].ammo_mag_slot[storage.weapons_data[wid].slot]=0
		storage.player_data[id].ammo_bag_slot[storage.weapons_data[wid].slot]=0
		parse('hudtxt2 '..id..' 0 "" 0 0')

		freeimage(storage.player_data[id].wpn_image_slot[slot])
		storage.player_data[id].wpn_image_slot[slot]=nil
		parse("strip "..id.." "..rwid)
	end
end
end

function swpn_equip_new_weapon(id,wid)
if player(id,"health") and player(id,"health")>0 and storage.weapons_data[wid] then
	if storage.player_data[id].wpn_id_slot[storage.weapons_data[wid].slot] ~= 0 then
		swpn_strip_new_weapon(id,wid)
	end

	local wslot=storage.weapons_data[wid].slot

	for _,dwid in pairs(playerweapons(id)) do
		if itemtype(dwid,"slot")==wslot then
			parse("strip "..id.." "..dwid)
		end
	end
	local rwid = storage.weapons_data[wid].real_id
	parse("equip "..id.." "..rwid.."")
	storage.player_data[id].wpn_id_slot[wslot]=wid
	storage.player_data[id].ammo_mag_slot[wslot]=storage.weapons_data[wid].ammo_mag
	storage.player_data[id].ammo_bag_slot[wslot]=storage.weapons_data[wid].ammo_bag
	
	parse("setammo "..id.." "..rwid.." 0")
	parse("setweapon "..id.." 50")
	local txtcolor = "©"..storage.ammo_hudtxt_color..""
	if storage.ammo_hudtxt_position == 1 then
		parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[wslot]..' | '..storage.player_data[id].ammo_bag_slot[wslot]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
	else
		parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[wslot]..' | '..storage.player_data[id].ammo_bag_slot[wslot]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
	end
	storage.player_data[id].wpn_image_slot[wslot]=image(storage.weapons_data[wid].path_e,3,0,200+id)
	imagescale(storage.player_data[id].wpn_image_slot[wslot],storage.weapons_data[wid].e_scale1,storage.weapons_data[wid].e_scale2)
	parse('sv_soundpos "items/pickup.wav" '..player(id, "x")..' '..player(id, "y"))
	end
end

function swpn_pickup_weapon(id,k)
local rwid=storage.weapons_data[storage.weapons_dropped[k].id].real_id
parse("equip "..id.." "..rwid.."")

storage.player_data[id].wpn_id_slot[storage.weapons_data[storage.weapons_dropped[k].id].slot]=storage.weapons_dropped[k].id
storage.player_data[id].ammo_mag_slot[storage.weapons_data[storage.weapons_dropped[k].id].slot]=storage.weapons_dropped[k].ammo_mag
storage.player_data[id].ammo_bag_slot[storage.weapons_data[storage.weapons_dropped[k].id].slot]=storage.weapons_dropped[k].ammo_bag

parse("setammo "..id.." "..rwid.." 0")
parse("setweapon "..id.." "..rwid.."")

	if storage.weapons_dropped[k].ammo_mag<storage.weapons_data[storage.weapons_dropped[k].id].ammo_mag then--fix for invisible reload after picking up
		if storage.weapons_dropped[k].ammo_bag>0 then--and reloading empty weapon
			parse("setammo "..id.." "..rwid.." 0 1")
		
		end
	end
	local txtcolor = "©"..storage.ammo_hudtxt_color..""
	if storage.ammo_hudtxt_position == 1 then
		parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]..' | '..storage.player_data[id].ammo_bag_slot[itemtype(player(id,"weapontype"),"slot")]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
	else
		parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]..' | '..storage.player_data[id].ammo_bag_slot[itemtype(player(id,"weapontype"),"slot")]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
	end

storage.player_data[id].wpn_image_slot[storage.weapons_data[storage.weapons_dropped[k].id].slot]=image(storage.weapons_data[storage.weapons_dropped[k].id].path_e,3,0,200+id)
imagescale(storage.player_data[id].wpn_image_slot[storage.weapons_data[storage.weapons_dropped[k].id].slot],storage.weapons_data[storage.weapons_dropped[k].id].e_scale1,storage.weapons_data[storage.weapons_dropped[k].id].e_scale2)

if not storage.weapons_dropped[k].infinite then
	if storage.weapons_dropped[k].respawn_timer then
		if not storage.weapons_dropped[k].on_spawn then
			storage.weapons_dropped[k].on_spawn = true
			local wid = storage.weapons_dropped[k].id
			local tx = storage.weapons_dropped[k].ent_tilex
			local ty = storage.weapons_dropped[k].ent_tiley
			local stime = storage.weapons_dropped[k].respawn_timer
			swpn_weapon_entity_respawn(wid,tx,ty,stime)
		end
	end
storage.weapons_dropped[k].id=0
end
parse('sv_soundpos "items/pickup.wav" '..player(id, "x")..' '..player(id, "y"))
end

function swpn_weapon_entity_respawn(wid,tx,ty,stime)
local k = #storage.weapon_respawns+1
storage.weapon_respawns[k] = {}
storage.weapon_respawns[k].id = wid
storage.weapon_respawns[k].tilex = tx
storage.weapon_respawns[k].tiley = ty
storage.weapon_respawns[k].delay = stime
storage.weapon_respawns[k].timer = 0
end

function swpn_fix_players_wpn_sprite(id)
	if itemtype(player(id,"weapontype"),"slot")==1 then
		if storage.player_data[id].wpn_id_slot[2]>0 then
			imagealpha(storage.player_data[id].wpn_image_slot[2],0,0)
		end
		if storage.player_data[id].wpn_id_slot[1]>0 then
		imagealpha(storage.player_data[id].wpn_image_slot[1],1,1)
		end
	elseif itemtype(player(id,"weapontype"),"slot")==2 then
		if storage.player_data[id].wpn_id_slot[1]>0 then
			imagealpha(storage.player_data[id].wpn_image_slot[1],0,0)
		end
		if storage.player_data[id].wpn_id_slot[2]>0 then
		imagealpha(storage.player_data[id].wpn_image_slot[2],1,1)
		end
	else
		if storage.player_data[id].wpn_id_slot[1]>0 then
			imagealpha(storage.player_data[id].wpn_image_slot[1],0,0)
		end
		if storage.player_data[id].wpn_id_slot[2]>0 then
			imagealpha(storage.player_data[id].wpn_image_slot[2],0,0)
		end
	end

end

function swpn_fix_shooting_knife(id)
if storage.player_data[id].wpn_id_slot[1]>0 then
	imagealpha(storage.player_data[id].wpn_image_slot[1],0,0)
end
if storage.player_data[id].wpn_id_slot[2]>0 then
	imagealpha(storage.player_data[id].wpn_image_slot[2],0,0)
end
end

function swpn_remove_hudwname(id)
--parse('hudtxtalphafade '..id..' 1 100 0')
--tween_alpha(hudtxt_back,100,0,0)
imagealpha(storage.player_data[id].hudtxt_back,0,0)
parse('hudtxt2 '..id..' 1 "" 0 0')
end

function swpn_dropped_fadeout(k)
storage.weapons_dropped[k].id=0
freeimage(storage.weapons_dropped[k].image)
storage.weapons_dropped[k].image=nil
storage.weapons_dropped[k]={}
end

addhook("second","swpn_second_hook")
function swpn_second_hook()
	for k, v in pairs(storage.weapons_dropped) do
	if storage.weapons_dropped[k].id then
		if storage.weapons_dropped[k].id>0 then
			if storage.weapons_dropped[k].fadeout_timer then
				if storage.weapons_dropped[k].fadeout_timer<tonumber(game("mp_weaponfadeout")) then
					storage.weapons_dropped[k].fadeout_timer=storage.weapons_dropped[k].fadeout_timer+1
					if storage.weapons_dropped[k].fadeout_timer==tonumber(game("mp_weaponfadeout")) then
						tween_alpha(storage.weapons_dropped[k].image,900,0,0)
					end
				elseif storage.weapons_dropped[k].fadeout_timer>=tonumber(game("mp_weaponfadeout")) then					
					swpn_dropped_fadeout(k)
				end
			end
		--elseif storage.weapons_dropped[k].id==0 then
			--storage.weapons_dropped[k]=nil
		end
	end
	end
	
	for k, v in pairs(storage.weapon_respawns) do
		if not storage.weapon_respawns[k].spawned then
			
			if storage.weapon_respawns[k].timer<storage.weapon_respawns[k].delay then
				storage.weapon_respawns[k].timer = storage.weapon_respawns[k].timer+1
			elseif storage.weapon_respawns[k].timer==storage.weapon_respawns[k].delay then
				storage.weapon_respawns[k].spawned = true
				local wid = storage.weapon_respawns[k].id
				local tx, ty = storage.weapon_respawns[k].tilex, storage.weapon_respawns[k].tiley
				local del = storage.weapon_respawns[k].delay
				swpn_spawn_new_weapon(wid,tx,ty,2,del)
				storage.weapon_respawns[k]=nil
			end
		end
	end
	
	storage.round_timer=storage.round_timer+1
end

addhook("clientdata","swpn_cldata_hook")
function swpn_cldata_hook(id,mode,d1,d2)
storage.player_data[id].cursor_x, storage.player_data[id].cursor_y = d1, d2
end

addhook("ms100","swpn_ms100_hook")
function swpn_ms100_hook()
	for _,id in pairs(player(0,"tableliving")) do
		--reqcld(id,2) --changing method of obtaining coords from reqcld to player(mousemap)
		local cur_mx, cur_my = player(id,"mousemapx"),player(id,"mousemapy")
		--reqcld(id,0)
		local cur_sx, cur_sy = swpn_get_cursor_screen(id)
		for k, v in pairs(storage.weapons_dropped) do
		if storage.weapons_dropped[k].id then
			if storage.weapons_dropped[k].id > 0 then
				if math.floor(cur_mx/32)==storage.weapons_dropped[k].tilex and math.floor(cur_my/32)==storage.weapons_dropped[k].tiley then
					local hudtxtcolor=0
					imagepos(storage.player_data[id].hudtxt_back,cur_sx+2,cur_sy+18,0)
					imagealpha(storage.player_data[id].hudtxt_back,0.4,0.4)
					imagescale(storage.player_data[id].hudtxt_back,string.len(storage.weapons_data[storage.weapons_dropped[k].id].name)+string.len(storage.weapons_dropped[k].ammo_mag)+string.len(storage.weapons_dropped[k].ammo_bag)-string.len(storage.weapons_data[storage.weapons_dropped[k].id].name)*0.1+1,1)
					if storage.weapons_data[storage.weapons_dropped[k].id].slot==1 then
						hudtxtcolor = 255255000
					else
						hudtxtcolor = 225195050
					end
					
					parse('hudtxt2 '..id..' 1 "©'..hudtxtcolor..' '..storage.weapons_data[storage.weapons_dropped[k].id].name..' ('..storage.weapons_dropped[k].ammo_mag..'|'..storage.weapons_dropped[k].ammo_bag..')" '..cur_sx..' '..(cur_sy+12)..' 1 0 11')
					freetimer("parse", "lua swpn_remove_hudwname("..id..")")
					timer(300, "parse", "lua swpn_remove_hudwname("..id..")")
				end
			end
		end
		end
		local islot = itemtype(player(id,"weapontype"),"slot")
		if storage.player_data[id].reload_in_process then
			if storage.player_data[id].reloading_slot~=islot then
				freetimer("parse", "lua swpn_reload_finish("..id..")")
				storage.player_data[id].reload_in_process=false
			end
		end
		swpn_fix_default_ammo_hud(id)
		swpn_fix_players_wpn_sprite(id)
		
		if islot==1 or islot==2 then--fix for reloaded default weapon when picking up ammo while reloading
			if storage.player_data[id].wpn_id_slot[islot]~=0 then
				if storage.player_data[id].ammo_mag_slot[islot]<storage.weapons_data[ storage.player_data[id].wpn_id_slot[islot]].ammo_mag then
					if storage.player_data[id].reload_in_process then
						parse("setammo "..id.." "..player(id,"weapontype").." 0 0")
					else
						parse("setammo "..id.." "..player(id,"weapontype").." 0 1")
					end
				else
					parse("setammo "..id.." "..player(id,"weapontype").." 0 0")
				end
			end
		end
		
		if storage.laser_sights>0 then
			if not storage.round_end then
				swpn_fix_laser_sight(id)
			end
		end
	end
end

function swpn_fix_laser_sight(id)
	if storage.player_data[id].laser then
		if itemtype(player(id,"weapontype"),"slot")==1 or itemtype(player(id,"weapontype"),"slot")==2 then
			if storage.laser_sights==1 and storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]==0 then
				imagealpha(storage.player_data[id].laser_img,0)
			else
				local dist = player(id,"mousedist")
				--print(dist)	
				if dist > 46  then 
					imagealpha(storage.player_data[id].laser_img,0.8)
					if dist>500 then
					-- >storage.mode2_shot_dist
						dist=500
					end
		
					local h = dist*0.67
					swpn_laser_freeline(id,dist)
				else
					imagealpha(storage.player_data[id].laser_img,0)
				end
			end
		else
			imagealpha(storage.player_data[id].laser_img,0)
		end
	end
end

function swpn_laser_sight(id)
if itemtype(player(id,"weapontype"),"slot")==1 or itemtype(player(id,"weapontype"),"slot")==2 then
	if storage.laser_sights==1 and storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]==0 then
		return
	end

	if not storage.player_data[id].laser then
		storage.player_data[id].laser=true
		imagealpha(storage.player_data[id].laser_img,0.8)
		--parse('sv_sound2 '..id..' "! 2gen weapons/laser_on.ogg"')
		parse('sv_soundpos "! 2gen weapons/laser_on.ogg" '..player(id, "x")..' '..player(id, "y"))--laser on/off sounds will be heard by all players
	else
		storage.player_data[id].laser=false
		imagealpha(storage.player_data[id].laser_img,0)
		--parse('sv_sound2 '..id..' "! 2gen weapons/laser_off.ogg"')
		parse('sv_soundpos "! 2gen weapons/laser_off.ogg" '..player(id, "x")..' '..player(id, "y"))
	end
end
end

function swpn_laser_color(id)
	local color = storage.player_data[id].laser_color+1
	if color > #storage.laser_colors then
		color=1
	end
	storage.player_data[id].laser_color=color	
	imagecolor(storage.player_data[id].laser_img,storage.laser_colors[color].r,storage.laser_colors[color].g,storage.laser_colors[color].b)
end

function swpn_laser_freeline(id,Dist)
	local sx, sy = player(id, "x"), player(id, "y")
	local Angle = swpn_AngleBetween(player(id, "x"), player(id, "y"), player(id, "mousemapx"), player(id, "mousemapy"))
	
	for i = 1, Dist, 8 do
		sx = sx + math.sin(Angle) * 8
		sy = sy - math.cos(Angle) * 8
				
		if tile(math.floor(sx/32), math.floor(sy/32), "wall") then
			local dist = swpn_DistBetween(sx, sy, player(id, "x"), player(id, "y"))
			
				imagescale(storage.player_data[id].laser_img,1,dist*0.67)

			return false
		end
	end
	imagescale(storage.player_data[id].laser_img,1,Dist*0.67)
end

function swpn_get_cursor_map(id)
--reqcld(id,2)
if not storage.recoil then
	storage.player_data[id].p_mx=player(id,"mousemapx")
	storage.player_data[id].p_my=player(id,"mousemapy")
else
	storage.player_data[id].p_mx, storage.player_data[id].p_my=swpn_math_recoil(id,player(id,"mousemapx"),player(id,"mousemapy"))
end
end

function swpn_if_widescreen(id)
--print(player(id,"screenw"))
--print(player(id,"screenh"))
local w = player(id,"screenw")
local h = player(id,"screenh")
	for k, v in pairs(storage.screen_res) do
		if v.w == w then
			if v.h == h then
				storage.player_data[id].widescreen=1
				return true
			end
		end
	end
	
	if storage.player_data[id].widescreen~=1 then
		storage.player_data[id].widescreen=-1
	end
end

function swpn_get_cursor_screen(id)--trying to reduce the amount of reqcld calls
	if storage.player_data[id].widescreen == 0 then
		swpn_if_widescreen(id)--check player screen
	end
	
	if storage.player_data[id].widescreen == 1 then	
		return math.floor(player(id,"mousex")/850*player(id,"screenw")),math.floor(player(id,"mousey")/480*player(id,"screenh")) --use custom formula to math cursor position for 16:9 res
	else
		reqcld(id,0) --idk how to fix cursor position at 4:3 resolution, so just use reqcld 
		return storage.player_data[id].cursor_x, storage.player_data[id].cursor_y
		--print("ERROR: Screen resolution not supported")
		--return math.floor(player(id,"mousex")/640*player(id,"screenw")),math.floor(player(id,"mousey")/480*player(id,"screenh"))
	end

end

function swpn_math_recoil(id,d1,d2)
local rec_f=storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].recoil_force
local rec_d1
local rec_d2
if storage.aim_mode==1 then
	rec_d1=math.random(d1-rec_f/2,d1+rec_f/2)
	rec_d2=math.random(d2-rec_f/2,d2+rec_f/2)
elseif storage.aim_mode==2 then
	rec_d1=math.random(d1-rec_f,d1+rec_f)
	rec_d2=math.random(d2-rec_f,d2+rec_f)
end

return rec_d1, rec_d2
end

function swpn_DistBetween(a, b, x, y)
	return math.sqrt((a - x)^2 + (b - y)^2)
end

function swpn_AngleBetween(...)-- 2nd function from NPC Mod :D
	if #arg < 4 then return nil end
	local Angle = math.atan2(arg[2] - arg[4],arg[1] - arg[3]) - math.pi/2
	if Angle < -math.pi then
		Angle = Angle + (math.pi*2)
	end
	return Angle
end

function swpn_points_angle(id)
--local storage.player_data[id].p_mx,storage.player_data[id].p_my = player(id,"mousemapx"),player(id,"mousemapy")
local x_at=player(id, "x")-storage.player_data[id].p_mx
local y_at=player(id, "y")-storage.player_data[id].p_my
return 90+180*math.atan2(y_at,x_at)/math.pi
end

function swpn_math_recoil_angle(id)
local rec_f = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].recoil_force
local rec_rot=player(id, "rot")-90+math.random(-rec_f,rec_f)
local dist = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].range
local rec_x=player(id,"x")+dist*math.cos(math.rad(rec_rot))
local rec_y=player(id,"y")+dist*math.sin(math.rad(rec_rot))

return rec_x, rec_y
end

function swpn_shotgun_freeline(id)
	local rec_f = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].recoil_force
	local dist = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].range
	
	local rec_rand = math.random(-rec_f,rec_f)
	local rec_rot1=player(id, "rot")-90+rec_rand	
	local rec_x, rec_y =player(id,"x")+dist*math.cos(math.rad(rec_rot1)), player(id,"y")+dist*math.sin(math.rad(rec_rot1))
	storage.player_data[id].p_mx, storage.player_data[id].p_my = rec_x, rec_y
	swpn_freeline(rec_x, rec_y, id, 1)
	
	local rec_rot2=rec_rot1+(8-(dist-300)/50)+math.random(1,4)
	rec_x, rec_y =player(id,"x")+dist*math.cos(math.rad(rec_rot2)), player(id,"y")+dist*math.sin(math.rad(rec_rot2))
	storage.player_data[id].p_mx, storage.player_data[id].p_my = rec_x, rec_y
	swpn_freeline(rec_x, rec_y, id, 2)

	local rec_rot3=rec_rot1-(8-(dist-300)/50)-math.random(1,4)
	rec_x, rec_y =player(id,"x")+dist*math.cos(math.rad(rec_rot3)), player(id,"y")+dist*math.sin(math.rad(rec_rot3))
	storage.player_data[id].p_mx, storage.player_data[id].p_my = rec_x, rec_y
	swpn_freeline(rec_x, rec_y, id, 3)
end

function swpn_circle_point(id)
local s_rot = player(id, "rot")-90
--local dist = storage.mode2_shot_dist
local dist = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].range
local cx = player(id,"x")+dist*math.cos(math.rad(s_rot))
local cy = player(id,"y")+dist*math.sin(math.rad(s_rot))
return cx, cy
end

function swpn_if_scope(id)
local wid = storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]
local dmg = storage.weapons_data[wid].damage
if storage.weapons_data[wid].type=="sniper 1x scope" or storage.weapons_data[wid].type=="sniper 2x scope" then
	if storage.player_data[id].scope == 1 then
		dmg=dmg*storage.weapons_data[wid].scope1x_damage_multiplier
	elseif storage.player_data[id].scope == 2 then
		dmg=dmg*storage.weapons_data[wid].scope2x_damage_multiplier
	end
end
dmg=math.floor(dmg*tonumber(game("mp_damagefactor")))
--print(dmg)
return dmg
end

function swpn_set_bullet_line(id,dist,sx,sy)
	imagescale(storage.player_data[id].bullet_line,1,dist-25)
	fix_x, fix_y = fix_xy(id,sx,sy)			
	imagepos(storage.player_data[id].bullet_line,fix_x,fix_y,swpn_points_angle(id))
end

function swpn_set_bullet_line_shotgun(id,dist,sx,sy,shot)
	fix_x, fix_y = fix_xy(id,sx,sy)
	if shot==1 then
		imagescale(storage.player_data[id].bullet_line,1,dist-25)
		imagepos(storage.player_data[id].bullet_line,fix_x,fix_y,swpn_points_angle(id))
	elseif shot==2 then
		imagescale(storage.player_data[id].bullet_line2,1,dist-25)
		imagepos(storage.player_data[id].bullet_line2,fix_x,fix_y,swpn_points_angle(id))
	elseif shot==3 then
		imagescale(storage.player_data[id].bullet_line3,1,dist-25)
		imagepos(storage.player_data[id].bullet_line3,fix_x,fix_y,swpn_points_angle(id))
	end
end

function swpn_freeline(...)--x,y,id; based on function from NPC Mod by Starkkz
	if #arg < 2 then 
		return nil 
	end
	
	local id = tonumber(arg[3])
	local sx, sy = player(id, "x"), player(id, "y")
	local Dist = swpn_DistBetween(player(id, "x"), player(id, "y"), arg[1], arg[2])
	local Angle = swpn_AngleBetween(player(id, "x"), player(id, "y"), arg[1], arg[2])
	
	for i = 1, Dist, 6 do
		sx = sx + math.sin(Angle) * 6
		sy = sy - math.cos(Angle) * 6
		
		local gf_dist = swpn_DistBetween(sx, sy, player(id, "x"), player(id, "y"))
		if gf_dist>40 then
			if storage.gunfire_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
				if i==49 then
				--print(i)
					imagealpha(storage.player_data[id].gunfire,1,1)
					tween_alpha(storage.player_data[id].gunfire,150,0,0)
				end
			end
		end
		
		local tsx, tsy = math.floor(sx/32), math.floor(sy/32)
		if tile(tsx, tsy, "wall") then
			local dist = swpn_DistBetween(sx, sy, player(id, "x"), player(id, "y"))
			if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then			
				if storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].type=="shotgun" then
					swpn_set_bullet_line_shotgun(id,dist,sx,sy,arg[4])
				else
					swpn_set_bullet_line(id,dist,sx,sy)
				end
			end
			parse("effect \"sparkles\" "..sx.." "..sy.." "..storage.sparkles_effect_value.." "..math.random(0,360).." 255 210 120")
			parse("effect \"colorsmoke\" "..sx.." "..sy.." 1 1 192 192 192")

			if objectat(tsx,tsy) then
				if storage.swpn_buildings_ids_tab[object(objectat(tsx,tsy),"type")] then
					parse('sv_soundpos "materials/stone'..math.random(1,3)..'.wav" '..sx..' '..sy)
					local dmg = swpn_if_scope(id)
					--storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].damage
					parse("damageobject "..objectat(tsx,tsy).." "..dmg.." "..id)
				end
			end
			
			if storage.explode_breakables then --ugly try to make custom weapon damage env_breakable
				if entity(tsx,tsy,"exists") then
					if entity(tsx,tsy,"type")==25 then
						if entity(tsx,tsy,"int1")>0 then
							local dmg = swpn_if_scope(id)
							parse("explosion "..(tsx*32+16).." "..(tsy*32+16).." 1 "..dmg.." "..id)
						end
					end
				end
			end
			return false
		end
		
		if storage.aim_mode==2 then
			for _,id2 in pairs(player(0,"tableliving")) do
				local dist_id2 = swpn_DistBetween(sx, sy, player(id2, "x"), player(id2, "y"))
				if dist_id2<(storage.player_hitbox+storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].hitbox_modifier) and id ~= id2 then
					local dist = swpn_DistBetween(sx, sy, player(id, "x"), player(id, "y"))
					if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
						if storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].type=="shotgun" then
							swpn_set_bullet_line_shotgun(id,dist,sx,sy,arg[4])
						else
							swpn_set_bullet_line(id,dist,sx,sy)
						end
					end
					swpn_damage_player(id,id2)
					return false
				--else
					
				end
			end
	
			for _,oid in pairs(closeobjects(sx,sy,storage.npc_hitbox+storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].hitbox_modifier)) do
				if object(oid,"type")==30 then
					local dist = swpn_DistBetween(sx, sy, player(id, "x"), player(id, "y"))
					if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
						if storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].type=="shotgun" then
							swpn_set_bullet_line_shotgun(id,dist,sx,sy,arg[4])
						else
							swpn_set_bullet_line(id,dist,sx,sy)
						end
					end
					local dmg = swpn_if_scope(id)
					parse("effect \"blood\" "..object(oid, "x").." "..object(oid, "y").." "..storage.blood_effects_value.." "..math.random(0,360).." 174 17 17")
					parse("damageobject "..oid.." "..dmg.." "..id)
					return false
				end
			end
			
				if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
					--local dist2 = storage.mode2_shot_dist
					if storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].type=="shotgun" then
						swpn_free_bullet_line_shotgun(id,arg[4])
					else
						swpn_free_bullet_line(id)
					end
				end
		end
	end
return true
end

function swpn_free_bullet_line(id)
	local dist2 = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].range
	fix_x, fix_y = fix_xy(id,storage.player_data[id].p_mx,storage.player_data[id].p_my)
	local rot = swpn_points_angle(id)
	imagepos(storage.player_data[id].bullet_line,fix_x,fix_y,rot)
	imagescale(storage.player_data[id].bullet_line,1,dist2-30)
end

function swpn_free_bullet_line_shotgun(id,shot)
	local dist2 = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].range
	fix_x, fix_y = fix_xy(id,storage.player_data[id].p_mx,storage.player_data[id].p_my)
	local rot = swpn_points_angle(id)
	
	if shot==1 then
		imagepos(storage.player_data[id].bullet_line,fix_x,fix_y,rot)
		imagescale(storage.player_data[id].bullet_line,1,dist2-30)
	elseif shot==2 then
		imagepos(storage.player_data[id].bullet_line2,fix_x,fix_y,rot)
		imagescale(storage.player_data[id].bullet_line2,1,dist2-30)
	elseif shot==3 then
		imagepos(storage.player_data[id].bullet_line3,fix_x,fix_y,rot)
		imagescale(storage.player_data[id].bullet_line3,1,dist2-30)
	end
end

function fix_xy(id,fx,fy)
local p_mx, p_my = fx, fy
if p_mx~=player(id,"x") or p_my~=player(id,"y") then
	if p_mx~=player(id,"x") then
		local half_x = math.abs(p_mx-player(id,"x"))*0.45
		if p_mx > player(id,"x") then
			fix_x = p_mx-half_x
		elseif p_mx < player(id,"x") then
			fix_x = p_mx+half_x
		end
	end
	
	if p_my~=player(id,"y") then
		local half_y = math.abs(p_my-player(id,"y"))*0.45
		if p_my > player(id,"y") then
			fix_y = p_my-half_y
		elseif p_my < player(id,"y") then
			fix_y = p_my+half_y
		end
	end
else
fix_x = p_mx
fix_y = p_my
end
return fix_x, fix_y
end

function swpn_timer_release(id)
id=tonumber(id)
storage.player_data[id].shoot_timer=false
end

function swpn_circle_point2(id,f)
local csx = player(id,"x")+f*math.cos(math.rad(player(id, "rot")-90))
local csy = player(id,"y")+f*math.sin(math.rad(player(id, "rot")-90))
return csx, csy
end

function swpn_screenw(id) --few formulas for calculating ammo hudtxt at all resolutions
return player(id,"screenw")-math.floor((player(id,"screenw")/6.8)) --200 for 1360x res
end

function swpn_screenh(id)
return player(id,"screenh")-math.floor((player(id,"screenw")/27)) --50
end

function swpn_screen_txtsize(id)
return math.floor(player(id,"screenw")/37) --36
end

function swpn_shot(id)
	local id=tonumber(id)
	if type(player(id,"health"))=="number" and player(id,"health")>0 then
		
		if storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")] and storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]>0 then
		
			if storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]>0 then
				
				local txtcolor = "©"..storage.ammo_hudtxt_color..""
				storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]=storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]-1
				if tonumber(game("mp_infammo"))==1 then
					if storage.ammo_hudtxt_position == 1 then
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]..' | inf" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
					else
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]..' | inf" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
					end
				else
					if storage.ammo_hudtxt_position == 1 then
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]..' | '..storage.player_data[id].ammo_bag_slot[itemtype(player(id,"weapontype"),"slot")]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
					else
						parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]..' | '..storage.player_data[id].ammo_bag_slot[itemtype(player(id,"weapontype"),"slot")]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
					end
				end
				
				local rand_wsound = math.random(1,#storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].sounds)
				parse('sv_soundpos "'..storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].sounds[rand_wsound]..'" '..player(id, "x")..' '..player(id, "y"))
				
				if storage.smoke_effects then
					local csx, csy = swpn_circle_point2(id,20)
					parse("effect \"smoke\" "..csx.." "..csy.." 1 1 150 150 150")
					--parse("effect \"fire\" "..csx.." "..csy.." 1 1 150 150 150")
				end
				
				if storage.gunfire_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
					
					if itemtype(player(id,"weapontype"),"slot")==1 then
						local frame=math.random(1,8)
						imageframe(storage.player_data[id].gunfire,frame)
						imagescale(storage.player_data[id].gunfire,0.5,0.8)
					elseif itemtype(player(id,"weapontype"),"slot")==2 then
						local frame=math.random(10,17)
						imageframe(storage.player_data[id].gunfire,frame)
						imagescale(storage.player_data[id].gunfire,0.4,0.7)
					end
				end
				
				local dist

				--[=[if storage.aim_mode==1 then
					swpn_get_cursor_map(id)
					dist = swpn_DistBetween(storage.player_data[id].p_mx, storage.player_data[id].p_my, player(id, "x"), player(id, "y"))
					if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
						imagecolor(storage.player_data[id].bullet_line,255,255,55)
					end
					if storage.gunfire_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
						imagealpha(storage.player_data[id].gunfire,1,1)
						tween_alpha(storage.player_data[id].gunfire,150,0,0)
					end

					if dist>60 then
						if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
							imagealpha(storage.player_data[id].bullet_line,0.6)
							tween_alpha(storage.player_data[id].bullet_line,60,0,0)
						end
					end
				end]=]
				if storage.aim_mode==2 then

					--dist = storage.mode2_shot_dist
					dist = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].range

					if not storage.recoil then
						storage.player_data[id].p_mx, storage.player_data[id].p_my = swpn_circle_point(id)
					else
						--local cx, cy = swpn_circle_point(id)
						--storage.player_data[id].p_mx, storage.player_data[id].p_my=swpn_math_recoil(id,cx,cy)
						storage.player_data[id].p_mx, storage.player_data[id].p_my = swpn_math_recoil_angle(id)
					end
					
					if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
						
						if storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].type=="shotgun" then
							imagealpha(storage.player_data[id].bullet_line,0.6)
							tween_alpha(storage.player_data[id].bullet_line,60,0,0)
							
							imagealpha(storage.player_data[id].bullet_line2,0.6)
							tween_alpha(storage.player_data[id].bullet_line2,60,0,0)
							
							imagealpha(storage.player_data[id].bullet_line3,0.6)
							tween_alpha(storage.player_data[id].bullet_line3,60,0,0)
						else
							imagealpha(storage.player_data[id].bullet_line,0.6)
							tween_alpha(storage.player_data[id].bullet_line,60,0,0)
						end
					end
				end

				--[=[if storage.aim_mode==1 then

					if swpn_freeline(storage.player_data[id].p_mx, storage.player_data[id].p_my, id) then
						fix_x, fix_y = fix_xy(id,storage.player_data[id].p_mx,storage.player_data[id].p_my)
						local x_at=player(id, "x")-storage.player_data[id].p_mx
						local y_at=player(id, "y")-storage.player_data[id].p_my
						
						if storage.bullet_line_sprite_effect and not storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].silence then
							imagepos(storage.player_data[id].bullet_line,fix_x,fix_y,swpn_points_angle(id))-- rot == player(id,"rot") if no recoil
							imagescale(storage.player_data[id].bullet_line,1,dist-30)
						end

						for _,id2 in pairs(player(0,"table")) do
							if swpn_DistBetween(storage.player_data[id].p_mx, storage.player_data[id].p_my, player(id2, "x"), player(id2, "y"))<(storage.player_hitbox+storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].hitbox_modifier) and id ~= id2 and player(id2, "health")>0 then
								if player(id,"team")==player(id2,"team") then
									if tonumber(game("sv_gamemode"))~=1 then 
										if tonumber(game("sv_friendlyfire")) == 1 then
											swpn_damage_player(id,id2)
											break
										end
									else
										swpn_damage_player(id,id2)
										break
									end
								else
									swpn_damage_player(id,id2)
									break
								end
							end
						end

						for _,oid in pairs(closeobjects(storage.player_data[id].p_mx,storage.player_data[id].p_my,storage.npc_hitbox+storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].hitbox_modifier)) do
							if object(oid,"type")==30 then
								parse("effect \"blood\" "..object(oid, "x").." "..object(oid, "y").." "..storage.blood_effects_value.." "..math.random(0,360).." 174 17 17")
								parse("damageobject "..oid.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].damage.." "..id)
								break--damage only 1 npc at the same position (means do not pierce npc/players, how is it done with default weapon, bcuz I dont like it, unrealistic)
							end
						end
	
					end
					end]=]
				
				if storage.aim_mode==2 then
					if storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].type=="shotgun" then
						swpn_shotgun_freeline(id)
					else
						swpn_freeline(storage.player_data[id].p_mx, storage.player_data[id].p_my, id)
					end
				end

				if storage.player_data[id].ammo_mag_slot[itemtype(player(id,"weapontype"),"slot")]>0 then
					swpn_auto_shot(id)
				end

			end
		end
	end
end

addhook("attack2","swpn_attack2_hook")
function swpn_attack2_hook(id,mode)
storage.player_data[id].scope = mode--now we can use default scopes for custom weapon without additional sprites
end

function swpn_calc_damage1(hp,armor,dmg,id,id2)
dmg = swpn_if_scope(id)

	if tonumber(game("sv_gamemode"))==4 and player(id2,"team")==1 then
		dmg=math.floor(dmg*tonumber(game("mp_zombiedmg")))
	end

if armor>=0 and armor<=200 then
	armor=armor-math.floor(dmg*tonumber(game("mp_kevlar")))
	if armor<0 then
		dmg=dmg-math.floor(dmg*tonumber(game("mp_kevlar")))+math.abs(armor)
		armor=0
		hp=hp-dmg
		return hp, armor
	else
		dmg=dmg-math.floor(dmg*tonumber(game("mp_kevlar")))
		hp=hp-dmg
		return hp, armor
	end

elseif armor==201 then
	dmg=math.floor(dmg*0.75)
	hp=hp-dmg
	return hp, armor
elseif armor==202 then
	dmg=math.floor(dmg*0.5)
	hp=hp-dmg
	return hp, armor
elseif armor==203 then
	dmg=math.floor(dmg*0.25)
	hp=hp-dmg
	return hp, armor
elseif armor==204 then
	dmg=math.floor(dmg*0.5)
	hp=hp-dmg
	return hp, armor
elseif armor==205 then
	dmg=math.ceil(dmg*0.05)
	hp=hp-dmg
	return hp, armor
elseif armor==206 then
	hp=hp-dmg
	return hp, armor
end
end

function swpn_calc_damage2(id,id2)--actually this is 1st calc_damage
local wid = storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]
local dmg = storage.weapons_data[wid].damage
local hp, armor = swpn_calc_damage1(player(id2,"health"), player(id2,"armor"), dmg, id,id2)
if hp > 0 then
	parse("sethealth "..id2.." "..hp)
	parse("setarmor "..id2.." "..armor)
	--print(dmg)
	--print(hp)
else
	parse("customkill "..id..' "'..storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].name..'"'.." "..id2)
end
end

function swpn_damage_player(id,id2)
	if tonumber(game("sv_gamemode"))~=1 then
		if player(id,"team")==player(id2,"team") then
			if tonumber(game("sv_friendlyfire")) == 1 then
				parse("effect \"blood\" "..player(id2, "x").." "..player(id2, "y").." "..storage.blood_effects_value.." "..math.random(0,360).." 174 17 17")
				parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..player(id2, "x")..' '..player(id2, "y"))
				
				swpn_calc_damage2(id,id2)
			end
		else
			parse("effect \"blood\" "..player(id2, "x").." "..player(id2, "y").." "..storage.blood_effects_value.." "..math.random(0,360).." 174 17 17")
			parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..player(id2, "x")..' '..player(id2, "y"))
			swpn_calc_damage2(id,id2)
		end
	else
		parse("effect \"blood\" "..player(id2, "x").." "..player(id2, "y").." "..storage.blood_effects_value.." "..math.random(0,360).." 174 17 17")
		parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..player(id2, "x")..' '..player(id2, "y"))
		swpn_calc_damage2(id,id2)
	end
end

function swpn_auto_shot(id)
if storage.player_data[id].mouse1_pressed then
	if not storage.player_data[id].shoot_timer then
		if not storage.player_data[id].reload_in_process then
			if itemtype(player(id,"weapontype"),"slot")<=2 then
				parse("setammo "..id.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].real_id.." 0 1")
				storage.player_data[id].shoot_timer=true
				local t = storage.weapons_data[storage.player_data[id].wpn_id_slot[itemtype(player(id,"weapontype"),"slot")]].fire_rate_timer
				timer(t, "parse", "lua swpn_timer_release("..id..")")
				timer(t, "parse", "lua swpn_shot("..id..")")
			end
		end
	end
end
end

addbind("mouse1")
addbind(storage.laser_hotkey)
addbind("R")
addbind("G")
addbind(storage.buy_menu_hotkey)
addbind(storage.laser_color_hotkey)
--addbind("mwheelup")--wheels binds is not valid in cs2d 1007, waiting for fix in next version (will be used in future to fix a 1 bullet shot while switching weapon with mouse wheel bug)
--addbind("mwheeldown")
addbind("3")
addbind("4")
addbind("5")

addhook("key","swpn_binds")
function swpn_binds(id,key,state)--main function
local id=tonumber(id)
if not player(id,"bot") then
if player(id,"health") and player(id,"health")>0 then
	local wslot = itemtype(player(id,"weapontype"),"slot")
	
	if key=="3" or key=="4" or key=="5" then
		if state==1 then
			local subslots = 0
			for _,i in pairs(playerweapons(id)) do
				if itemtype(i,"slot")==tonumber(key) then
					subslots = subslots+1
				end
			end
			
			if subslots>1 then
				if wslot==1 or wslot==2 then
					storage.player_data[id].w_selecting = 1
				end
			end
		end
	end
	
	if key=="mouse1" then
		if wslot<=2 then
			if not storage.player_data[id].reload_in_process then			
				if state==1 then
					if storage.player_data[id].w_selecting == 1 then
						storage.player_data[id].w_selecting = 0
						return
					end
					storage.player_data[id].mouse1_pressed=true

					if not storage.player_data[id].shoot_timer then
						--player_first_shot=true
						swpn_shot(id)
					end

				elseif state==0 then
					storage.player_data[id].mouse1_pressed=false
					freetimer("parse", "lua swpn_shot("..id..")")

				end
			end
		end
	end
	
	--if key=="mwheelup" or key=="mwheeldown" then
		--if state==1 then
			--storage.player_data[id].w_selecting = 1
		--end
	--end
	
	if key=="R" and not storage.player_data[id].reload_in_process and wslot<=2 then
		if storage.player_data[id].wpn_id_slot[wslot]>0 then
			if storage.player_data[id].ammo_mag_slot[wslot] < storage.weapons_data[storage.player_data[id].wpn_id_slot[wslot]].ammo_mag then
				if storage.player_data[id].ammo_bag_slot[wslot] > 0 then
					if state==1 then
						if storage.player_data[id].mouse1_pressed then
							freetimer("parse", "lua swpn_shot("..id..")")
						end
						parse("setammo "..id.." "..storage.weapons_data[storage.player_data[id].wpn_id_slot[wslot]].real_id.." 0 1")
						storage.player_data[id].reload_in_process=true
						storage.player_data[id].reloading_slot=wslot
						--parse('sv_soundpos "weapons/w_clipout.wav" '..player(id, "x")..' '..player(id, "y"))
						
						timer(storage.reload_timers[storage.weapons_data[storage.player_data[id].wpn_id_slot[wslot]].real_id]*5, "parse", "lua swpn_reload_finish("..id..")")
					end
				end
			end
		end
	end
	
	if key=="G" then
		if state==1 then
			if storage.player_data[id].wpn_id_slot[wslot] and storage.player_data[id].wpn_id_slot[wslot]>0 then
				storage.player_data[id].slot_to_drop=wslot
			end
			--fix for dropping prev used item in drop hook
			swpn_drop_bind(id)
		end
	end
	
	if key==storage.laser_color_hotkey then
		if state==1 then
			if storage.laser_sights>0 then
				if not storage.round_end then
					swpn_laser_color(id)
				end
			end
		end
	end
	
	if key==storage.laser_hotkey then
		if state==1 then
			if storage.laser_sights>0 then
				if not storage.round_end then
					swpn_laser_sight(id)
				end
			end
		end
	end
	
	if key==storage.buy_menu_hotkey then
		if state==1 then
			if storage.custom_buy_menu then
				if not storage.round_end then
					if not storage.buy_menu_always then --X menu made to be looks like B menu
						if map"nobuying"==0 then
							if (60*tonumber(game("mp_buytime")))>storage.round_timer then
								if player(id,"team")==1 then
									if inentityzone(player(id,"tilex"),player(id,"tiley"),0) then
										storage.player_data[id].menu_page = 1
										swpn_create_buymenu(id, 1)
										parse("setweapon "..id.." 50")
									else
										parse("sv_msg2 "..id.." \169255000000You are not in a buyzone@C")--default massages copy-paste
									end
								elseif player(id,"team")==2 or player(id,"team")==3 then
									if inentityzone(player(id,"tilex"),player(id,"tiley"),1) then
										storage.player_data[id].menu_page = 1
										swpn_create_buymenu(id, 1)
										parse("setweapon "..id.." 50")
									else
										parse("sv_msg2 "..id.." \169255000000You are not in a buyzone@C")
									end
								end
							else
								parse("sv_msg2 "..id.." \169255000000Buytime passed - you can't buy anymore@C")
							end
						else
							parse("sv_msg2 "..id.." \169255000000Buying is not allowed@C")
						end		
					else
						storage.player_data[id].menu_page = 1
						swpn_create_buymenu(id, 1)
						parse("setweapon "..id.." 50")
					end
				end
			end
		end
	end
end
end
end

function swpn_reload_finish(id)
storage.player_data[id].reload_in_process=false
if storage.player_data[id].reloading_slot==itemtype(player(id,"weapontype"),"slot") then
	swpn_reload_weapon(id)
end
end

function swpn_reload_weapon(id)
local id=tonumber(id)
local wslot = itemtype(player(id,"weapontype"),"slot")
local ammo_mag = storage.player_data[id].ammo_mag_slot[wslot]
local max_ammo_mag = storage.weapons_data[storage.player_data[id].wpn_id_slot[wslot]].ammo_mag
local need_ammo = max_ammo_mag - ammo_mag
local ammo_bag = storage.player_data[id].ammo_bag_slot[wslot]
	if tonumber(game("mp_infammo"))==1 then
		ammo_bag = storage.weapons_data[storage.player_data[id].wpn_id_slot[wslot]].ammo_bag
	end

	if need_ammo > ammo_bag then
		ammo_mag = ammo_mag+ammo_bag
		storage.player_data[id].ammo_mag_slot[wslot] = ammo_mag
		storage.player_data[id].ammo_bag_slot[wslot] = 0
	elseif need_ammo <= ammo_bag then
		ammo_mag = ammo_mag + need_ammo
		ammo_bag = ammo_bag - need_ammo
		storage.player_data[id].ammo_mag_slot[wslot] = ammo_mag
		storage.player_data[id].ammo_bag_slot[wslot] = ammo_bag
	end
	local txtcolor = "©"..storage.ammo_hudtxt_color..""
	--parse('sv_soundpos "weapons/w_clipin.wav" '..player(id, "x")..' '..player(id, "y"))
	if tonumber(game("mp_infammo"))==1 then
		storage.player_data[id].ammo_bag_slot[wslot] = storage.weapons_data[storage.player_data[id].wpn_id_slot[wslot]].ammo_bag
		if storage.ammo_hudtxt_position == 1 then
			parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[wslot]..' | inf " '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
		else
			parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[wslot]..' | inf " '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
		end
	else
		if storage.ammo_hudtxt_position == 1 then
			parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[wslot]..' | '..storage.player_data[id].ammo_bag_slot[wslot]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..'')
		else
			parse('hudtxt2 '..id..' 0 "'..txtcolor..' '..storage.player_data[id].ammo_mag_slot[wslot]..' | '..storage.player_data[id].ammo_bag_slot[wslot]..'" '..swpn_screenw(id)..' '..swpn_screenh(id)..' 0 0 '..swpn_screen_txtsize(id)..'')
		end
	end
end

function swpn_create_buymenu(id, page)--automate the X menu

	local buttons_t = {
		[1] = "",
		[2] = "",
		[3] = "",
		[4] = "",
		[5] = "",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
	}
	local text = "Buy Custom Weapons,"
	
	page=page-1
	
	for i=1,6 do
		if storage.weapons_data[i+6*page] then
			if storage.weapons_data[i+6*page].cost==-1 then
				buttons_t[i] = "("..storage.weapons_data[i+6*page].name..")"
			else
				buttons_t[i] = storage.weapons_data[i+6*page].name .. "| " .. storage.weapons_data[i+6*page].cost
			end
		end
	end
	
	if storage.weapons_data[7+6*page] then
		buttons_t[9] = "Next Page|Page " .. storage.player_data[id].menu_page+1
	end
	
	if page>0 then
		buttons_t[8] = "Prev Page"
	end
		
	text = text .. ''..buttons_t[1]..','..buttons_t[2]..','..buttons_t[3]..','..buttons_t[4]..','..buttons_t[5]..','..buttons_t[6]..',,'..buttons_t[8]..','..buttons_t[9]..''
	menu(id, text)
end

function swpn_buy_item(id,i)
if not storage.round_end then
	local page=storage.player_data[id].menu_page-1

	if not (tonumber(game("sv_gamemode"))==4 and player(id,"team")==1) then
		if player(id,"money") >= storage.weapons_data[i+6*page].cost then 
			parse("setmoney "..id.." "..player(id,"money")-storage.weapons_data[i+6*page].cost)
			swpn_equip_new_weapon(id,storage.weapons_data[i+6*page].id)
		else
			parse("sv_msg2 "..id.." \169255000000You have insufficient funds@C")
		end
	else
		parse("sv_msg2 "..id.." \169255000000You're not allowed to buy anything@C")
	end
end
end

addhook("menu","swpn_menu_hook")
function swpn_menu_hook(id,title,button)
	if player(id,"health") <= 0 then 
		return 
	end	
	
	if title:find "Buy Custom Weapons" then
		if button<=6 and button~=0 then
			swpn_buy_item(id,button)
		end
				
		local page = storage.player_data[id].menu_page
		if button == 9 then
			storage.player_data[id].menu_page=storage.player_data[id].menu_page+1
			swpn_create_buymenu(id, (page+1))
		elseif button == 8 then
			storage.player_data[id].menu_page=storage.player_data[id].menu_page-1
			swpn_create_buymenu(id, (page-1))			
		end
	end
end

addhook("buy","swpn_buy_hook")--now fix the B menu
function swpn_buy_hook(id,weapon)
	if storage.player_data[id].wpn_id_slot[itemtype(weapon,"slot")] then	
		if storage.player_data[id].wpn_id_slot[itemtype(weapon,"slot")] >0 then
			swpn_strip_new_weapon(id,storage.player_data[id].wpn_id_slot[itemtype(weapon,"slot")])
		end
	end
end

addhook("usebutton","swpn_usebutton_hook")--add buttons for shop in map editor
function swpn_usebutton_hook(id,btilex,btiley)
	if entity(btilex,btiley,"trigger")=="wshop" then
		if not entity(btilex,btiley,"state") then
			storage.player_data[id].menu_page = 1
			swpn_create_buymenu(id,1)
		end
		
	elseif entity(btilex,btiley,"name")=="aim_mode" then--switch just for tutorial map
		if not entity(btilex,btiley,"state") then
		if storage.aim_mode == 2 then
			storage.aim_mode = 1
			parse("sv_msg \169255000000Aim Mode is 1 (hard)@C")
		elseif storage.aim_mode == 1 then
			storage.aim_mode = 2
			parse("sv_msg \169255000000Aim Mode is 2 (classic)@C")
		end
		end
	end
end

--
--
--made by 2Gen, pm me if you have any qq.
--
--